--- main/udptl.c~	2008-12-19 20:53:11.000000000 -0500
+++ main/udptl.c	2008-12-23 23:50:28.000000000 -0500
@@ -750,7 +750,7 @@
 void ast_udptl_set_local_max_datagram(struct ast_udptl* udptl, int max_datagram)
 {
 	if (udptl)
-		udptl->local_max_datagram_size = max_datagram;
+		udptl->local_max_datagram_size = max_datagram > udptlmaxdatagram ? udptlmaxdatagram : max_datagram;
 	else
 		ast_log(LOG_WARNING, "udptl structure is null\n");
 }
--- channels/chan_sip.c~	2008-12-23 23:34:37.000000000 -0500
+++ channels/chan_sip.c	2008-12-24 01:24:22.000000000 -0500
@@ -7329,12 +7329,17 @@
 			peert38capability &= (T38FAX_RATE_14400 | T38FAX_RATE_12000 | T38FAX_RATE_9600 | T38FAX_RATE_7200 | T38FAX_RATE_4800 | T38FAX_RATE_2400);
 			p->t38.jointcapability |= (peert38capability & p->t38.capability); /* Put the lower of our's and peer's speed */
 		}
-		if (debug)
+		if (debug) {
 			ast_debug(1, "Our T38 capability = (%d), peer T38 capability (%d), joint T38 capability (%d)\n",
 				p->t38.capability,
 				p->t38.peercapability,
 				p->t38.jointcapability);
 
+			ast_debug(1, "Our T38 datagram size = (%d), peer T38 datagram size (%d), joint T38 datagram size (%d)\n",
+				ast_udptl_get_local_max_datagram(p->udptl),
+				ast_udptl_get_far_max_datagram(p->udptl), 
+				ast_udptl_get_local_max_datagram(p->udptl));
+		}
 		/* Remote party offers T38, we need to update state */
 		if (t38action == SDP_T38_ACCEPT) {
 			if (p->t38.state == T38_LOCAL_DIRECT || p->t38.state == T38_LOCAL_REINVITE)
